MODULE UserTraps;
(* =========================================================================  
   Example ARM Cortex-M Oberon Program  
 
   Description:
     Demonstrates the user-defined trapping and identification of runtime errors.
  
   Target:
     All supported Cortex-M systems
     
   References: 
     The Programming Language Oberon
     Oberon for Cortex-M Microcontrollers
   
   (c) 2018 CFB Software   
   http://www.astrobe.com  
   
   ========================================================================= *)

IMPORT Main, Traps, Out;

CONST
  DivZeroTrap = Traps.MinUserTrap;

PROCEDURE DivZeroHandler(id: Traps.ID);
BEGIN
  Out.String("Module : "); Out.String(id.modName); Out.Ln;
  Out.String("Line no: "); Out.Int(id.lineNo, 0); Out.Ln;
  Out.String("Division by Zero"); Out.Ln
END DivZeroHandler;
  
PROCEDURE DivByZero();
VAR
  r11, r10, r9: INTEGER;
BEGIN
  r11 := 11;
  r10 := 0;
  r9 := 9;
  (* Trap on division by zero *)
  ASSERT(r10 # 0, DivZeroTrap);
  r9 := r11 DIV r10
END DivByZero;

BEGIN
  Traps.SetUserHandler(DivZeroTrap, DivZeroHandler);
  DivByZero()
END UserTraps.

